Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4501)
+++ palm/trunk/SOURCE/modules.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! +restart_data_format, restart_data_format_input|output, include_total_domain_boundaries
 ! 
@@ -229,8 +232,10 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_e              !< artificial numerical dissipation flux at south face of grid box - subgrid-scale TKE
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_nc             !< artificial numerical dissipation flux at south face of grid box - clouddrop-number concentration
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_ni             !< artificial numerical dissipation flux at south face of grid box - ice crystal-number concentration
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_nr             !< artificial numerical dissipation flux at south face of grid box - raindrop-number concentration
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_pt             !< artificial numerical dissipation flux at south face of grid box - potential temperature
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_q              !< artificial numerical dissipation flux at south face of grid box - mixing ratio
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_qc             !< artificial numerical dissipation flux at south face of grid box - cloudwater
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_qi             !< artificial numerical dissipation flux at south face of grid box - ice crystal mixing ratio
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_qr             !< artificial numerical dissipation flux at south face of grid box - rainwater
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_s              !< artificial numerical dissipation flux at south face of grid box - passive scalar
@@ -244,8 +249,10 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_e              !< 6th-order advective flux at south face of grid box - subgrid-scale TKE
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_nc             !< 6th-order advective flux at south face of grid box - clouddrop-number concentration
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_ni             !< 6th-order advective flux at south face of grid box - icecrystal-number concentration
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_nr             !< 6th-order advective flux at south face of grid box - raindrop-number concentration
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_pt             !< 6th-order advective flux at south face of grid box - potential temperature
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_q              !< 6th-order advective flux at south face of grid box - mixing ratio
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_qc             !< 6th-order advective flux at south face of grid box - cloudwater
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_qi             !< 6th-order advective flux at south face of grid box - ice crystal
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_qr             !< 6th-order advective flux at south face of grid box - rainwater
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_s              !< 6th-order advective flux at south face of grid box - passive scalar
@@ -271,8 +278,10 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_e    !< artificial numerical dissipation flux at left face of grid box - subgrid-scale TKE
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_nc   !< artificial numerical dissipation flux at left face of grid box - clouddrop-number concentration
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_ni   !< artificial numerical dissipation flux at left face of grid box - ice crystal-number concentration
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_nr   !< artificial numerical dissipation flux at left face of grid box - raindrop-number concentration
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_pt   !< artificial numerical dissipation flux at left face of grid box - potential temperature
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_q    !< artificial numerical dissipation flux at left face of grid box - mixing ratio
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_qc   !< artificial numerical dissipation flux at left face of grid box - cloudwater
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_qi   !< artificial numerical dissipation flux at left face of grid box - ice crystal
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_qr   !< artificial numerical dissipation flux at left face of grid box - rainwater
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_s    !< artificial numerical dissipation flux at left face of grid box - passive scalar
@@ -284,8 +293,10 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_e    !< 6th-order advective flux at south face of grid box - subgrid-scale TKE
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_nc   !< 6th-order advective flux at south face of grid box - clouddrop-number concentration
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_ni   !< 6th-order advective flux at south face of grid box - ice crystal-number concentration
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_nr   !< 6th-order advective flux at south face of grid box - raindrop-number concentration
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_pt   !< 6th-order advective flux at south face of grid box - potential temperature
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_q    !< 6th-order advective flux at south face of grid box - mixing ratio
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_qc   !< 6th-order advective flux at south face of grid box - cloudwater
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_qi   !< 6th-order advective flux at south face of grid box - ice crystal
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_qr   !< 6th-order advective flux at south face of grid box - rainwater
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_s    !< 6th-order advective flux at south face of grid box - passive scalar
@@ -324,4 +335,7 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nc_2    !< pointer for swapping of timelevels for respective quantity
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nc_3    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ni_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ni_2    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ni_3    !< pointer for swapping of timelevels for respective quantity
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_1    !< pointer for swapping of timelevels for respective quantity
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_2    !< pointer for swapping of timelevels for respective quantity
@@ -336,4 +350,7 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_2    !< pointer for swapping of timelevels for respective quantity
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_3    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qi_1    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qi_2    !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qi_3    !< pointer for swapping of timelevels for respective quantity
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v    !< pointer: volume of liquid water
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp   !< pointer: liquid water weighting factor
@@ -367,4 +384,6 @@
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  nc         !< pointer: cloud drop number density
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  nc_p       !< pointer: prognostic value of cloud drop number density
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  ni         !< pointer: ice crystal number density
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  ni_p       !< pointer: prognostic value of ice crystal number density
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  nr         !< pointer: rain drop number density
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  nr_p       !< pointer: prognostic value of rain drop number density
@@ -375,5 +394,7 @@
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  q_p        !< pointer: prognostic value of mixing ratio
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  qc         !< pointer: cloud water content
-    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  qc_p       !< pointer: cloud water content
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  qc_p       !< pointer: prognostic value cloud water content
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  qi         !< pointer: ice crystal content
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  qi_p       !< pointer: prognostic value ice crystal content
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  ql         !< pointer: liquid water content
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  ql_c       !< pointer: change in liquid water content due to
@@ -389,8 +410,10 @@
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  te_m       !< pointer: weighted tendency of e for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tnc_m      !< pointer: weighted tendency of nc for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tni_m      !< pointer: weighted tendency of ni for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tnr_m      !< pointer: weighted tendency of nr for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tpt_m      !< pointer: weighted tendency of pt for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tq_m       !< pointer: weighted tendency of q for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tqc_m      !< pointer: weighted tendency of qc for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tqi_m      !< pointer: weighted tendency of qi for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  tqr_m      !< pointer: weighted tendency of qr for previous sub-timestep (Runge-Kutta)
     REAL(wp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  ts_m       !< pointer: weighted tendency of s for previous sub-timestep (Runge-Kutta)
@@ -462,4 +485,5 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  lpt_av        !< avg. liquid water potential temperature
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nc_av         !< avg. cloud drop number density
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ni_av         !< avg. ice crystal number density
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_av         !< avg. rain drop number density
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p_av          !< avg. perturbation pressure
@@ -471,4 +495,5 @@
                                                                       !< (or total water content with active cloud physics)
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_av         !< avg. cloud water content
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qi_av         !< avg. ice crystal content
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_av         !< avg. liquid water content
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_c_av       !< avg. change in liquid water content due to
@@ -1423,8 +1448,10 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_ws2_ws_l    !< subdomain sum of vertical momentum flux w'w' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsncs_ws_l  !< subdomain sum of vertical clouddrop-number concentration flux w'nc' (5th-order advection scheme only)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsnis_ws_l  !< subdomain sum of vertical ice crystal concentration flux w'ni' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsnrs_ws_l  !< subdomain sum of vertical raindrop-number concentration flux w'nr' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wspts_ws_l  !< subdomain sum of vertical sensible heat flux w'pt' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqs_ws_l   !< subdomain sum of vertical latent heat flux w'q' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqcs_ws_l  !< subdomain sum of vertical cloudwater flux w'qc' (5th-order advection scheme only)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqis_ws_l  !< subdomain sum of vertical ice crystal flux w'qi' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqrs_ws_l  !< subdomain sum of vertical rainwater flux w'qr' (5th-order advection scheme only)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wssas_ws_l  !< subdomain sum of vertical salinity flux w'sa' (5th-order advection scheme only)
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4455 2020-03-11 12:20:29Z Giersch
 ! Axis attribute added to netcdf output
 ! 
@@ -880,5 +883,5 @@
                 CASE ( 'e', 'nc', 'nr', 'p', 'pc', 'pr', 'prr',                &
                        'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
-                       's', 'theta', 'thetal', 'thetav' )
+                       's', 'theta', 'thetal', 'thetav', 'qi', 'ni' )
 
                    grid_x = 'x'
@@ -1644,5 +1647,5 @@
                 CASE ( 'e', 'nc', 'nr', 'p', 'pc', 'pr', 'prr',   &
                        'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
-                       's', 'theta', 'thetal', 'thetav' )
+                       's', 'theta', 'thetal', 'thetav', 'qi', 'ni' )
 
                    grid_x = 'x'
@@ -2659,7 +2662,7 @@
 !
 !--                   Most variables are defined on the zu grid
-                      CASE ( 'e_xy', 'nc_xy', 'nr_xy', 'p_xy',                 &
+                      CASE ( 'e_xy', 'nc_xy', 'ni_xy', 'nr_xy', 'p_xy',        &
                              'pc_xy', 'pr_xy', 'prr_xy', 'q_xy',               &
-                             'qc_xy', 'ql_xy', 'ql_c_xy', 'ql_v_xy',           &
+                             'qc_xy', 'qi_xy', 'ql_xy', 'ql_c_xy', 'ql_v_xy',  &
                              'ql_vp_xy', 'qr_xy', 'qv_xy',                     &
                              's_xy',                                           &
@@ -3583,6 +3586,6 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_xz', 'nc_xz', 'nr_xz', 'p_xz', 'pc_xz',           &
-                          'pr_xz', 'prr_xz', 'q_xz', 'qc_xz',                  &
+                   CASE ( 'e_xz', 'nc_xz', 'ni_xz', 'nr_xz', 'p_xz', 'pc_xz',  &
+                          'pr_xz', 'prr_xz', 'q_xz', 'qc_xz', 'qi_xz',         &
                           'ql_xz', 'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz',  &
                           'qv_xz', 's_xz',                                     &
@@ -4460,6 +4463,6 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_yz', 'nc_yz', 'nr_yz', 'p_yz', 'pc_yz',           &
-                          'pr_yz','prr_yz', 'q_yz', 'qc_yz', 'ql_yz',          &
+                   CASE ( 'e_yz', 'nc_yz', 'ni_yz', 'nr_yz', 'p_yz', 'pc_yz',  &
+                          'pr_yz','prr_yz', 'q_yz', 'qc_yz', 'qi_yz', 'ql_yz', &
                           'ql_c_yz', 'ql_v_yz', 'ql_vp_yz', 'qr_yz', 'qv_yz',  &
                           's_yz',                                              &
@@ -5853,5 +5856,5 @@
 !
 !--             Most variables are defined on the zu levels
-                CASE ( 'e', 'nc', 'nr', 'p', 'pc', 'pr', 'prr',   &
+                CASE ( 'e', 'nc', 'nr', 'p', 'pc', 'pr', 'prr', 'ni', 'qi',    &
                        'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
                        'rho_sea_water', 's', 'sa', &
Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4500 2020-04-17 10:12:45Z suehring
 ! - Correct output of ground/wall heat flux at USM surfaces
 ! - Add conversion factor to heat and momentum-flux output
@@ -1695,4 +1698,62 @@
                ENDIF
 
+            CASE ( 'qis' )
+!
+!--            Output of instantaneous data
+               IF ( av == 0 )  THEN
+                  CALL surface_data_output_collect( surf_def_h(0)%qis,         &
+                                               surf_def_h(1)%qis,              &
+                                               surf_lsm_h%qis,                 &
+                                               surf_usm_h%qis,                 &
+                                               surf_def_v(0)%qis,              &
+                                               surf_lsm_v(0)%qis,              &
+                                               surf_usm_v(0)%qis,              &
+                                               surf_def_v(1)%qis,              &
+                                               surf_lsm_v(1)%qis,              &
+                                               surf_usm_v(1)%qis,              &
+                                               surf_def_v(2)%qis,              &
+                                               surf_lsm_v(2)%qis,              &
+                                               surf_usm_v(2)%qis,              &
+                                               surf_def_v(3)%qis,              &
+                                               surf_lsm_v(3)%qis,              &
+                                               surf_usm_v(3)%qis )
+               ELSE
+!
+!--               Output of averaged data
+                  surfaces%var_out(:) = surfaces%var_av(:,n_out) /             &
+                                        REAL( average_count_surf, KIND=wp )
+                  surfaces%var_av(:,n_out) = 0.0_wp
+
+               ENDIF
+
+            CASE ( 'nis' )
+!
+!--            Output of instantaneous data
+               IF ( av == 0 )  THEN
+                  CALL surface_data_output_collect( surf_def_h(0)%nis,         &
+                                               surf_def_h(1)%nis,              &
+                                               surf_lsm_h%nis,                 &
+                                               surf_usm_h%nis,                 &
+                                               surf_def_v(0)%nis,              &
+                                               surf_lsm_v(0)%nis,              &
+                                               surf_usm_v(0)%nis,              &
+                                               surf_def_v(1)%nis,              &
+                                               surf_lsm_v(1)%nis,              &
+                                               surf_usm_v(1)%nis,              &
+                                               surf_def_v(2)%nis,              &
+                                               surf_lsm_v(2)%nis,              &
+                                               surf_usm_v(2)%nis,              &
+                                               surf_def_v(3)%nis,              &
+                                               surf_lsm_v(3)%nis,              &
+                                               surf_usm_v(3)%nis )
+               ELSE
+!
+!--               Output of averaged data
+                  surfaces%var_out(:) = surfaces%var_av(:,n_out) /             &
+                                        REAL( average_count_surf, KIND=wp )
+                  surfaces%var_av(:,n_out) = 0.0_wp
+
+               ENDIF
+
             CASE ( 'qrs' )
 !
@@ -2153,4 +2214,63 @@
                                                surf_lsm_v(3)%ncsws,            &
                                                surf_usm_v(3)%ncsws )
+               ELSE
+!
+!--               Output of averaged data
+                  surfaces%var_out(:) = surfaces%var_av(:,n_out) /             &
+                                        REAL( average_count_surf, KIND=wp )
+                  surfaces%var_av(:,n_out) = 0.0_wp
+
+               ENDIF
+
+
+            CASE ( 'qisws' )
+!
+!--            Output of instantaneous data
+               IF ( av == 0 )  THEN
+                  CALL surface_data_output_collect( surf_def_h(0)%qisws,       &
+                                               surf_def_h(1)%qisws,            &
+                                               surf_lsm_h%qisws,               &
+                                               surf_usm_h%qisws,               &
+                                               surf_def_v(0)%qisws,            &
+                                               surf_lsm_v(0)%qisws,            &
+                                               surf_usm_v(0)%qisws,            &
+                                               surf_def_v(1)%qisws,            &
+                                               surf_lsm_v(1)%qisws,            &
+                                               surf_usm_v(1)%qisws,            &
+                                               surf_def_v(2)%qisws,            &
+                                               surf_lsm_v(2)%qisws,            &
+                                               surf_usm_v(2)%qisws,            &
+                                               surf_def_v(3)%qisws,            &
+                                               surf_lsm_v(3)%qisws,            &
+                                               surf_usm_v(3)%qisws )
+               ELSE
+!
+!--               Output of averaged data
+                  surfaces%var_out(:) = surfaces%var_av(:,n_out) /             &
+                                        REAL( average_count_surf, KIND=wp )
+                  surfaces%var_av(:,n_out) = 0.0_wp
+
+               ENDIF
+
+            CASE ( 'nisws' )
+!
+!--            Output of instantaneous data
+               IF ( av == 0 )  THEN
+                  CALL surface_data_output_collect( surf_def_h(0)%nisws,       &
+                                               surf_def_h(1)%nisws,            &
+                                               surf_lsm_h%nisws,               &
+                                               surf_usm_h%nisws,               &
+                                               surf_def_v(0)%nisws,            &
+                                               surf_lsm_v(0)%nisws,            &
+                                               surf_usm_v(0)%nisws,            &
+                                               surf_def_v(1)%nisws,            &
+                                               surf_lsm_v(1)%nisws,            &
+                                               surf_usm_v(1)%nisws,            &
+                                               surf_def_v(2)%nisws,            &
+                                               surf_lsm_v(2)%nisws,            &
+                                               surf_usm_v(2)%nisws,            &
+                                               surf_def_v(3)%nisws,            &
+                                               surf_lsm_v(3)%nisws,            &
+                                               surf_usm_v(3)%nisws )
                ELSE
 !
@@ -3120,4 +3240,40 @@
                                            surf_usm_v(3)%ncs, n_out )
 
+            CASE ( 'qis' )
+               CALL surface_data_output_sum_up( surf_def_h(0)%qis,             &
+                                           surf_def_h(1)%qis,                  &
+                                           surf_lsm_h%qis,                     &
+                                           surf_usm_h%qis,                     &
+                                           surf_def_v(0)%qis,                  &
+                                           surf_lsm_v(0)%qis,                  &
+                                           surf_usm_v(0)%qis,                  &
+                                           surf_def_v(1)%qis,                  &
+                                           surf_lsm_v(1)%qis,                  &
+                                           surf_usm_v(1)%qis,                  &
+                                           surf_def_v(2)%qis,                  &
+                                           surf_lsm_v(2)%qis,                  &
+                                           surf_usm_v(2)%qis,                  &
+                                           surf_def_v(3)%qis,                  &
+                                           surf_lsm_v(3)%qis,                  &
+                                           surf_usm_v(3)%qrs, n_out )
+
+            CASE ( 'nis' )
+               CALL surface_data_output_sum_up( surf_def_h(0)%nis,             &
+                                           surf_def_h(1)%nis,                  &
+                                           surf_lsm_h%nis,                     &
+                                           surf_usm_h%nis,                     &
+                                           surf_def_v(0)%nis,                  &
+                                           surf_lsm_v(0)%nis,                  &
+                                           surf_usm_v(0)%nis,                  &
+                                           surf_def_v(1)%nis,                  &
+                                           surf_lsm_v(1)%nis,                  &
+                                           surf_usm_v(1)%nis,                  &
+                                           surf_def_v(2)%nis,                  &
+                                           surf_lsm_v(2)%nis,                  &
+                                           surf_usm_v(2)%nis,                  &
+                                           surf_def_v(3)%nis,                  &
+                                           surf_lsm_v(3)%nis,                  &
+                                           surf_usm_v(3)%nis, n_out )
+
             CASE ( 'qrs' )
                CALL surface_data_output_sum_up( surf_def_h(0)%qrs,             &
@@ -3411,4 +3567,40 @@
                                            surf_lsm_v(3)%ncsws,                &
                                            surf_usm_v(3)%ncsws, n_out )
+
+            CASE ( 'qisws' )
+               CALL surface_data_output_sum_up( surf_def_h(0)%qisws,           &
+                                           surf_def_h(1)%qisws,                &
+                                           surf_lsm_h%qisws,                   &
+                                           surf_usm_h%qisws,                   &
+                                           surf_def_v(0)%qisws,                &
+                                           surf_lsm_v(0)%qisws,                &
+                                           surf_usm_v(0)%qisws,                &
+                                           surf_def_v(1)%qisws,                &
+                                           surf_lsm_v(1)%qisws,                &
+                                           surf_usm_v(1)%qisws,                &
+                                           surf_def_v(2)%qisws,                &
+                                           surf_lsm_v(2)%qisws,                &
+                                           surf_usm_v(2)%qisws,                &
+                                           surf_def_v(3)%qisws,                &
+                                           surf_lsm_v(3)%qisws,                &
+                                           surf_usm_v(3)%qisws, n_out )
+
+            CASE ( 'nisws' )
+               CALL surface_data_output_sum_up( surf_def_h(0)%nisws,           &
+                                           surf_def_h(1)%nisws,                &
+                                           surf_lsm_h%nisws,                   &
+                                           surf_usm_h%nisws,                   &
+                                           surf_def_v(0)%nisws,                &
+                                           surf_lsm_v(0)%nisws,                &
+                                           surf_usm_v(0)%nisws,                &
+                                           surf_def_v(1)%nisws,                &
+                                           surf_lsm_v(1)%nisws,                &
+                                           surf_usm_v(1)%nisws,                &
+                                           surf_def_v(2)%nisws,                &
+                                           surf_lsm_v(2)%nisws,                &
+                                           surf_usm_v(2)%nisws,                &
+                                           surf_def_v(3)%nisws,                &
+                                           surf_lsm_v(3)%nisws,                &
+                                           surf_usm_v(3)%nisws, n_out )
 
             CASE ( 'qrsws' )
@@ -4533,5 +4725,5 @@
                unit = 'm/s'
 
-            CASE ( 'ss', 'qcs', 'ncs', 'qrs', 'nrs' )
+            CASE ( 'ss', 'qcs', 'ncs', 'qis', 'nis', 'qrs', 'nrs' )
                unit = '1'
 
@@ -4545,5 +4737,5 @@
                unit = 'm2/s2'
 
-            CASE ( 'qcsws', 'ncsws', 'qrsws', 'nrsws', 'sasws' )
+            CASE ( 'qcsws', 'ncsws', 'qisws', 'nisws', 'qrsws', 'nrsws', 'sasws' )
 
             CASE ( 'shf' )
